CREATE OR REPLACE FUNCTION CTB_HIST_REC(
P_CDHISTPADR IN HISTPADR.CDHISTPADR%TYPE,
P_CDFILIAL IN FILIAL.CDFILIAL%TYPE,
P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
P_NRSEQVENREC IN CONTARECEBER.NRSEQVENREC%TYPE,
P_NRPARCELAREC IN CONTARECEBER.NRPARCELAREC%TYPE,
P_CDAJUCTREC IN TIPOAJRECEBER.CDAJUCTREC%TYPE
) RETURN VARCHAR2

AS
   V_DSHISTPADR VARCHAR2(200); -- Varivel que ser retornada com o Historico
   V_DSAJUSTE TIPOAJRECEBER.DSAJUCTREC%TYPE;
BEGIN
   BEGIN
      SELECT DSHISTPADR
        INTO V_DSHISTPADR
        FROM HISTPADR
       WHERE CDHISTPADR = P_CDHISTPADR;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DSHISTPADR :=  NULL;
   END;

   FOR C_HIST IN
      (SELECT CL.NMRAZSOCCLIE, CL.NMFANTCLIE, CL.NRINSJURCLIE, NF.CDFILIEMIT, NF.NRNOTAFISC,
              NF.NRLANCTONF, TP.DSTPCTRECEB, CT.DSCONTAREC
         FROM CONTARECEBER CT, TIPOCTRECEBER TP, NOTAFISCAL NF, CLIENTE CL
     WHERE CT.CDFILIAL = P_CDFILIAL
          AND CT.NRLANCTONF = P_NRLANCTONF
          AND CT.NRSEQVENREC = P_NRSEQVENREC
          AND CT.NRPARCELAREC = P_NRPARCELAREC
          AND CT.CDTPCTRECEB = TP.CDTPCTRECEB
          AND CT.CDFILIAL = NF.CDFILIAL
          AND CT.NRLANCTONF = NF.NRLANCTONF
          AND NF.CDCLIENTE = CL.CDCLIENTE) LOOP

      V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[FIL]', C_HIST.CDFILIEMIT);
      V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[DOC]', C_HIST.NRNOTAFISC);
      V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[SEQ]', C_HIST.NRLANCTONF);
      V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[TCR]', C_HIST.DSTPCTRECEB);
      V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[DCR]', C_HIST.DSCONTAREC);
      V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[CLI]', C_HIST.NRINSJURCLIE);
      V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[NFC]', C_HIST.NMFANTCLIE);
      V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[RSC]', C_HIST.NMRAZSOCCLIE);
      V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[NCR]', C_HIST.DSTPCTRECEB);
   END LOOP;

   FOR C_FOS IN
      (SELECT DISTINCT MV.CDFILIAL,MV.CDCAIXA, R.NRECFREDZ, R.NRREDREDZ
         FROM MOVCAIXA MV, REDUCAOZ R
 	     WHERE MV.CDFILIALNF = P_CDFILIAL
          AND MV.NRLANCTONF = P_NRLANCTONF
          AND MV.CDFILIAL = R.CDFILIAL
	       AND MV.CDCAIXA  = R.CDCAIXA
		    AND TRUNC(MV.DTMOVIMCAIXA) = R.DTREDUCAOZ) LOOP
                 V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[ECF]', C_FOS.NRECFREDZ);
		 V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[CXA]', C_FOS.CDCAIXA);
		 V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[RED]', C_FOS.NRREDREDZ);
   END LOOP;

   IF P_CDAJUCTREC IS NOT NULL THEN
      BEGIN
         SELECT DSAJUCTREC
           INTO V_DSAJUSTE
           FROM TIPOAJRECEBER
          WHERE CDAJUCTREC = P_CDAJUCTREC;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DSAJUSTE := NULL;
      END;
   END IF;

   V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[TAR]', P_CDAJUCTREC);
   V_DSHISTPADR := REPLACE(V_DSHISTPADR, '[DAR]', V_DSAJUSTE);

   RETURN V_DSHISTPADR;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CTB_HIST_BAIXA_REC','5.50.000'); END;
/
